/* * * * * * * * * * * * * * * * * * * * * * */
/*      SETKISS - Set TNC to KISS mode       */
/*       (c) OE3GMW & OE1HHC 07.10.93        */
/*                                           */
/*       Support Programm fr TFKISS         */
/* * * * * * * * * * * * * * * * * * * * * * */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <conio.h>


/*                                            lokale Funktionsprototypen  */
/**************************************************************************/
static   unsigned  pascal is_loaded(void);
static   unsigned  pascal kiss_if(unsigned, char);
static   void      pascal put_line(char *);
static   void      pascal putstrkiss_if (char *);
static   void      pascal set_kiss(char *);


/*                                                      globale Variable  */
/**************************************************************************/
char   k_cmd[] = {'\x1B', '@', 'K', '\0'};/* der K-Kommandostring         */
unsigned tfpcr_int;                       /* von TFKISS benutzter Vektor  */


/*                                                         here we start  */
/**************************************************************************/
void main(int argc, char **argv)
{
  directvideo = 0;
  if (!(tfpcr_int = is_loaded())) {
    cprintf("    Fatal error. Hostmode interface not found!\r\n\n"\
            "    SETKISS cannot be used as a standalone application program.\r\n"\
            "    Load hostmode interface driver first!\r\n\7");
    exit(1);
  }

  cprintf(" ͻ\r\n" \
          "     SetKiss       Version 1.20    \r\n" \
          "       \r\n" \
          "  (c) OE3GMW & OE1HHC  %s \r\n" \
          " ͼ\r\n\n", __DATE__);

  if (argc == 2) {                      /* Auswertung der Kommandozeile   */
    if ((strlen(argv[1]) == 1) && (*argv[1] == '0'))
      set_kiss((char *)1);
    else
      set_kiss(argv[1]);
  }
  else
    set_kiss(NULL);

  exit(0);
}



/*                  Interrupttabelle nach installiertem Code durchsuchen  */
/**************************************************************************/
static unsigned pascal is_loaded(void)
{
  unsigned  i = 0x100;

  while (i-- > 0x2f) {
    if (!_fmemcmp(((char far *)getvect(i) + 3), "N5NX", 4))
      return(i);
  }
  return(0);
}


/*                                     String an Kiss interface ausgeben  */
/**************************************************************************/
static void pascal putstrkiss_if (char *s)
{
  while (*s)
    kiss_if(3, *s++);
}


/*                             KISS interface call fr Funktionen 0 .. 3  */
/**************************************************************************/
static unsigned pascal kiss_if(unsigned cmd, char ch)
{
  union   REGS    cpu;

  cpu.h.ah = cmd;
  cpu.h.al = ch;
  int86(tfpcr_int, &cpu, &cpu);
  return(cpu.h.al);
}


/*                                 Zeilenpuffer an KISS interface senden  */
/**************************************************************************/
static void pascal put_line(char *buf)
{
  char *p = buf;

    while (*p) {
      if ((*p == '#') || (*p == ';') || (*p == '\n'))
        *p = '\0';             /* String gegebenenfalls vorzeitig beenden */
      else
        p++;
    }
                                     /* p zeigt auf die NULL Terminierung */
    p--;                 /* Space oder Tab Zeichen vom Zeilenende lschen */
    while ((p >= buf) && ((*p == ' ') || (*p == '\x9')))
      *p-- = '\0';

    p = buf;               /* Registervariable fr schnelleren Zugriff... */
    if (*p) {                   /* gibt es berhaupt Zeichen zum Ausgeben */
      if (*p == ':')                 /* nicht setkiss sondern TF-Kommando */
        *p = '\x1B';
      else
        putstrkiss_if(k_cmd);                       /* Esc @ K  aussenden */
      putstrkiss_if(buf);
      kiss_if(3, '\r');                       /* Zeile mit CR abschlieen */
    }

    while (kiss_if(1, 0))                 /* Zeichen vom Host Interface   */
      putch(kiss_if(2, 0));               /* auf den Bildschirm ausgeben  */
}



/*                                        Datei an KISS interface senden  */
/**************************************************************************/
static void pascal set_kiss(char *fn)
{
  FILE  *fd;
  char   buf[128];

  if (fn == (char *)1) {
    put_line(" 0");
    cprintf("\r\n***  TNC should be off KISS mode now  ***\r\n");
    return;
  }

  if (fn == NULL)
    fn = "AUTOKISS.CFG";
  else
    strupr(fn);

  if ((fd = fopen(fn, "rt")) == NULL) {
    cprintf("%s - File not found!\r\n\7", fn);
    exit(1);
  }

  cprintf("*** sending file %s to TNC ***\r\n\n", fn);

  while (fgets(buf, sizeof(buf), fd))
    put_line(buf);

  fclose(fd);
  cprintf("\r\n***  TNC should be in KISS mode now  ***\r\n");
}

/* Ende von SETKISS */
